﻿using System.Web.Mvc;
using System.Web.Routing;
using InnovaApp.Layers.SecurityLayer.Models.AccountModels.MembershipServices;

namespace InnovaApp.Layers.SecurityLayer.Controllers
{
	public class LogOffController : Controller
	{
		public IFormsAuthenticationService FormsService { get; set; }
		public IMembershipService MembershipService { get; set; }

		/// <summary>
		/// Initializes data that might not be available when the constructor is called.
		/// </summary>
		/// <param name="requestContext">The HTTP context and route data.</param>
		protected override void Initialize(RequestContext requestContext)
		{
			if (FormsService == null) { FormsService = new FormsAuthenticationService(); }
			if (MembershipService == null) { MembershipService = new AccountMembershipService(); }

			base.Initialize(requestContext);
		}

		#region LogOff
		/// <summary>
		/// URL: /LogOff
		/// </summary>
		/// <returns></returns>
		[Authorize]
		public ActionResult Index()
		{
			FormsService.SignOut();
			Session.Abandon();
			return RedirectPermanent("~/");
		}

		#endregion
	}
}
