﻿using System;
using System.Security.Principal;
using System.Web;
using System.Web.Security;
using INNOVACALL.Framework.Common.Logging;

namespace InnovaApp.Layers.SecurityLayer.Models.AccountModels.MembershipServices
{
    public class FormsAuthenticationService : IFormsAuthenticationService
    {
        public void SignIn(string userName, bool createPersistentCookie)
        {
            if (String.IsNullOrEmpty(userName)) throw new ArgumentException("Value cannot be null or empty.", "userName");
            FormsAuthentication.SetAuthCookie(userName, createPersistentCookie);
            HttpContext.Current.User = new GenericPrincipal(new GenericIdentity(userName, "Forms"), null);
            Logger.Info(enLog.Business, string.Format("Application [{0}] User [{1}] connected", Membership.ApplicationName, userName));
        }

        public void SignOut()
        {
            FormsAuthentication.SignOut();
            MembershipUser currentUser = Membership.GetUser();
            if (currentUser != null)
            {
                Logger.Info(enLog.Business, string.Format("Application [{0}] User [{1}] logged out", Membership.ApplicationName, currentUser.UserName));
            }
        }
    }
}