﻿using System.ComponentModel.DataAnnotations;
using InnovaApp.Layers.ResourcesLayer.Properties;
using InnovaApp.Layers.SecurityLayer.Models.AccountModels.MembershipValidation;
using INNOVACALL.Framework.Common.MVCHelpers.Localization;

namespace InnovaApp.Layers.SecurityLayer.Models.MetaData
{
	public class ChangePassword_MetaData : _MetaData_Base
	{
		[Display(Name = "Id")]
		public System.Guid MembershipUserId { get; set; }

		[Required]
		[DataType(DataType.Password)]
		[DisplayNameLocalizedEntityAttribute(typeof(Resources), "ChangePassword", "Account", "OldPassword")]
		public string OldPassword { get; set; }

		[Required]
		[DataType(DataType.Password)]
		[ValidatePasswordLength(ErrorMessageResourceName = "ChangePassword_PasswordLength", ErrorMessageResourceType = typeof(Resources))]
		[DisplayNameLocalizedEntityAttribute(typeof(Resources), "ChangePassword", "Account", "NewPassword")]
		public string NewPassword { get; set; }
	}
}
