﻿using System.Web.Mvc;
using System.Web.Routing;

namespace InnovaApp.Portals.MVC4Portal
{
    public class RouteConfig
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "DynamicJS", // Route name
                "ScriptsG/{action}.js", // URL with parameters
                new { controller = "ScriptsG", action = "inoHomeDynamic", type = "js" } // Parameter defaults
            );

            routes.MapRoute(
                "DynamicCSS", // Route name
                "CSSG/{action}.css", // URL with parameters
                new { controller = "CSSG", action = "Site", type = "css" } // Parameter defaults
            );

            routes.MapRoute(
                "HttpError", // Route name
                "HttpError/{action}/{id}", // URL with parameters
                new { controller = "HttpError", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );

            routes.MapRoute(
                name: "Default",
                url: "{controller}/{action}/{id}",
                defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional }
            );
        }
    }
}