﻿using System.Web.Mvc;
using InnovaApp.Layers.DataLayer;
using InnovaApp.Layers.ResourcesLayer.Properties;
using InnovaApp.Portals.MVC4Portal.Models;
using INNOVACALL.Framework.Common;
using INNOVACALL.Framework.Common.MVCHelpers;

namespace InnovaApp.Portals.MVC4Portal.Controllers
{
    public class ContactUsController : _Controllers_Base<ContactModel>
    {
		protected override void Initialize(System.Web.Routing.RequestContext requestContext)
		{
			base.eMethodBase = "InnovaApp.Portals.InnovaAppFrontOfficePortal.Controllers.ContactController";
			base.specificCssCollection = new string[] { "_FormCommon.css", "Views/Contact.css", "ClientComponents/KendoUI/kendo.common.min.css", "ClientComponents/KendoUI/kendo.blueopal.min.css" };
			base.specificJSCollection = null;
			base.dynamicJSCollection = new string[] { "/ScriptsG/inoContactDynamic.js" };
			base.specificJqueryJSCollection = new string[] { "ClientComponents/KendoUI/kendo.web.min.js", "InnovacallJS/Contact/Contact.js" };
			base.externalCSS = null;
			base.Meta.Add(enMeta.Description, Resources.View_Contact_Meta_Description);
			base.Meta.Add(enMeta.Keywords, Resources.View_Contact_OrderWithDetails_Meta_Keywords);
			base.Meta.Add(enMeta.Subject, Resources.View_Contact_OrderWithDetails_Meta_Subject);

			base.Initialize(requestContext);
		}
		//
        // GET: /Contact/
		[HttpGet,Authorize,CacheManager(enCacheMode.NoCache)]
        public ActionResult Index()
        {
			using (DataRepositories _context = new DataRepositories())
			{
                base.InitView(
                    Resources.View_Contact_PageTitle,
                    Resources.View_Contact_PageMessage,
                    specificCssCollection,
                    specificJSCollection,
                    dynamicJSCollection,
                    specificJqueryJSCollection,
                    jsVariables,
                    externalCSS,
                    Meta,
                    _context,
                    true);
            }
			return View(ContentData);
		}
    }
}
