﻿using System.Web.Mvc;
using InnovaApp.Layers.ResourcesLayer.Properties;
using InnovaApp.Portals.MVC4Portal.Models.ScriptsGModels;

namespace InnovaApp.Portals.MVC4Portal.Controllers
{
	public class ScriptsGController: Controller
    {
		/// <summary>
		/// GET: /ScriptsG/inoHomeDynamic.js
		/// </summary>
		/// <returns></returns>
		public ActionResult inoHomeDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Home");
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
		/// <summary>
		/// GET: /ScriptsG/inoLogOnDynamic.js
		/// </summary>
		/// <returns></returns>
		public ActionResult inoLogOnDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "LogOn");
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>
        /// GET: /ScriptsG/inoSample_SingleControl_DropDownListDynamic.js
        /// </summary>
        /// <returns></returns>
		public ActionResult inoSample_SingleControl_DropDownListDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Sample_SingleControl_DropDownList");
			toReturn.Variables.Add("ErrMsg_Sample_SingleControl_DropDownList_CannotUpdate", Resources.ErrMsg_Sample_SingleControl_DropDownList_CannotUpdate);
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>
        /// GET: /ScriptsG/inoSample_SingleControl_TextBoxDynamic.js
        /// </summary>
        /// <returns></returns>
		public ActionResult inoSample_SingleControl_TextBoxDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Sample_SingleControl_TextBox");
			toReturn.Variables.Add("ErrMsg_Sample_SingleControl_TextBox_CannotUpdate", Resources.ErrMsg_Sample_SingleControl_TextBox_CannotUpdate);
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>
        /// GET: /ScriptsG/inoAdvancedSamples_OrderWithDetailsDynamic.js
        /// </summary>
        /// <returns></returns>
		public ActionResult inoAdvancedSamples_OrderWithDetailsDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "AdvancedSamples_OrderWithDetails");
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>
        /// GET: /ScriptsG/inoSample_BasicForm_MyProfileDynamic.js
        /// </summary>
        /// <returns></returns>
		public ActionResult inoSample_BasicForm_MyProfileDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Sample_BasicForm_MyProfile");
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>
        /// GET: /ScriptsG/inoDiagramsDynamic.js
        /// </summary>
        /// <returns></returns>
		public ActionResult inoDiagramsDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Diagrams");
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>
        /// GET: /ScriptsG/inoChangePasswordDynamic.js
        /// </summary>
        /// <returns></returns>
		public ActionResult inoChangePasswordDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Diagrams");
			Response.ContentType = "text/javascript";
			return View(toReturn);
		}
        /// <summary>²
        /// GET: /ScriptsG/inoAdvancedSamples_AddressesManagementDynamic.js
        /// </summary>
        /// <returns></returns>
        public ActionResult inoAdvancedSamples_AddressesManagementDynamic()
		{
			inoScriptGModel toReturn = new inoScriptGModel();
			toReturn.Variables.Add("ControllerName", "Diagrams");
			Response.ContentType = "text/javascript";
            toReturn.Variables.Add("ErrMsgAddressRetrieval_Title", Resources.View_AdvancedSamples_AddressesManagement_ErrMsgTitleErrorWhileRetrievingAddress);
            toReturn.Variables.Add("ErrMsgAtLeastOneAddressTypeMustBeSelected_Title", Resources.View_AdvancedSamples_AddressesManagement_ErrMsgAtLeastOneAddressTypeMustBeSelected_Title);
            toReturn.Variables.Add("ErrMsgAtLeastOneAddressTypeMustBeSelected_Message", Resources.View_AdvancedSamples_AddressesManagement_ErrMsgAtLeastOneAddressTypeMustBeSelected_Message);
            toReturn.Variables.Add("DeleteDialogConfirmTitle",Resources.View_AdvancedSamples_AddressesManagement_DeleteDialogConfirmTitle);
            toReturn.Variables.Add("DeleteDialogConfirmMessage",Resources.View_AdvancedSamples_AddressesManagement_DeleteDialogConfirmMessage);
            toReturn.Variables.Add("DeleteDialogConfirmConfirmButtonTitle",Resources.View_AdvancedSamples_AddressesManagement_DeleteDialogConfirmConfirmButtonTitle);
            toReturn.Variables.Add("DeleteDialogCancelConfirmButtonTitle", Resources.View_AdvancedSamples_AddressesManagement_DeleteDialogCancelConfirmButtonTitle);
            return View(toReturn);
		}
	}
}
