﻿using System.Collections.Generic;
using System.Web.Mvc;
using InnovaApp.Portals.MVC4Portal.Models.MetaModels;
using INNOVACALL.Framework.Common.Models;

namespace InnovaApp.Portals.MVC4Portal.Models
{
	/// <summary>
	/// View model for Order With Details Demo
	/// </summary>
	public class AdvancedSamples_OrderWithDetailsModel : _Models_Base
	{
		/// <summary>
		/// Order meta model contains database fields innherited from metadata layer and 
		/// view specific members like drop down list contents or any non database persistant objects
		/// </summary>
		public Order_MetaModel CurrentOrder { get; set; }
		/// <summary>
		/// List of available VAT
		/// </summary>
		public List<SelectListItem> VATs { get; set; }
		/// <summary>
		/// List of available products
		/// </summary>
		public List<SelectListItem> Products { get; set; }
		/// <summary>
		/// Involved code
		/// </summary>
		public InvolvedCodeModel InvolvedCode { get; set; }

		/// <summary>
		/// Neutral constructor
		/// </summary>
		/// 
		public AdvancedSamples_OrderWithDetailsModel()
			: base()
		{
            this.CurrentOrder = new Order_MetaModel();
            this.VATs = new List<SelectListItem>();
			this.Products = new List<SelectListItem>();
			this.InvolvedCode = null;
		}
	}
}